'use strict';

let through = require('through2');

const PLUGIN_NAME = 'gulp-assets';

let gulpAssets = ( url ) => {

    return through.obj((file, enc, cb) => {

        if(file.isBuffer()){
            let fileString = file.contents.toString();

            if(url && url !== ''){

                if(url.substr(url.length - 1) === '/'){
                    url = url.substr(0, url.length - 1);
                }

                // 替换 img
                fileString = fileString.replace(/(\.\.\/\.\.\/img\/|\.\.\/img\/|\.\/img\/)/g, url + '/img/');

                 // 替换 img
                 const regexp = new RegExp(`\\.\\.\\/\\.\\.\\/img\\/|\\.\\.\\/img\\/|\\.\\/img\\/`, 'gim');
                 fileString = fileString.replace(regexp, url + `/img/`);

                // 替换 css
                fileString = fileString.replace(/(\.\.\/\.\.\/css\/|\.\.\/css\/|\.\/css\/)/g, url + '/css/');

                // 替换 js
                fileString = fileString.replace(/(\.\.\/\.\.\/js\/|\.\.\/js\/|\.\/js\/)/g, url + '/js/');

                // 替换 assets
                fileString = fileString.replace(/(\.\.\/\.\.\/assets\/|\.\.\/assets\/|\.\/assets\/)/g, url + '/assets/');

                file.contents = new Buffer(fileString || '');

                cb(null, file);
                return;
            } else {
                // let srcPath = './';

                // 替换 img
                // fileString = fileString.replace(/(\.\.\/\.\.\/img\/|\.\.\/img\/|\.\/img\/)/g, srcPath + 'img/');

                // 替换 css
                // fileString = fileString.replace(/(\.\.\/\.\.\/css\/|\.\.\/css\/|\.\/css\/)/g, srcPath + 'css/');

                // 替换 js
                // fileString = fileString.replace(/(\.\.\/\.\.\/js\/|\.\.\/js\/|\.\/js\/)/g, srcPath + 'js/');

                file.contents = new Buffer(fileString || '');

                cb(null, file);
                return;
            }
        }

        cb(null, file);
    });

};

module.exports = gulpAssets;
