'use strict';

var through = require('through2');
var gutil = require('gulp-util');
var Path = require('path');
var fs = require('fs-extra');
var glob = require('glob');

function parsePath(path) {
    var extname = Path.extname(path);
    return {
        dirname: Path.dirname(path),
        basename: Path.basename(path, extname),
        extname: extname,
    };
}

module.exports = function ( path, callback ) {

    var i = 0;

    return through.obj(function (file, enc, cb) {

        ++i;

        glob(`${ path }/ejs/*.ejs`, {}, function (er, files) {
            if ( i >= files.length) {
                if ( callback ) callback( i );
                i = 0;
            }
        })

        const name = parsePath(file.relative);
        const filename = `${ name.basename }${ name.extname }`;

        const lastStr = path.substring(path.length - 1);

        if ( lastStr != '/' && lastStr != '\\' ) {
            path = `${ path }/`
        }

        fs.outputFile(`${ path }${ filename }`, file.contents.toString(), err => {
            cb(null);
        })

        // cb(null);

    });
};
